require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_CDEFS_H_)) {
    eval 'sub _SYS_CDEFS_H_ () {1;}' unless defined(&_SYS_CDEFS_H_);
    if(defined(&_KERNEL)  && defined(&_STANDALONE)) {
	die("_KERNEL and _STANDALONE are mutually exclusive");
    }
    unless(defined(&__has_attribute)) {
	eval 'sub __has_attribute {
	    my($x) = @_;
    	    eval q(0);
	}' unless defined(&__has_attribute);
    }
    unless(defined(&__has_extension)) {
	eval 'sub __has_extension () { &__has_feature;}' unless defined(&__has_extension);
    }
    unless(defined(&__has_feature)) {
	eval 'sub __has_feature {
	    my($x) = @_;
    	    eval q(0);
	}' unless defined(&__has_feature);
    }
    unless(defined(&__has_include)) {
	eval 'sub __has_include {
	    my($x) = @_;
    	    eval q(0);
	}' unless defined(&__has_include);
    }
    unless(defined(&__has_builtin)) {
	eval 'sub __has_builtin {
	    my($x) = @_;
    	    eval q(0);
	}' unless defined(&__has_builtin);
    }
    if(defined(&__cplusplus)) {
	eval 'sub __BEGIN_DECLS () { &extern "C" {;}' unless defined(&__BEGIN_DECLS);
	eval 'sub __END_DECLS () {};}' unless defined(&__END_DECLS);
    } else {
	eval 'sub __BEGIN_DECLS () {1;}' unless defined(&__BEGIN_DECLS);
	eval 'sub __END_DECLS () {1;}' unless defined(&__END_DECLS);
    }
    if(defined(&__GNUC__)) {
	eval 'sub __GNUC_PREREQ__ {
	    my($ma, $mi) = @_;
    	    eval q(( &__GNUC__ > ($ma) ||  &__GNUC__ == ($ma)  &&  &__GNUC_MINOR__ >= ($mi)));
	}' unless defined(&__GNUC_PREREQ__);
    } else {
	eval 'sub __GNUC_PREREQ__ {
	    my($ma, $mi) = @_;
    	    eval q(0);
	}' unless defined(&__GNUC_PREREQ__);
    }
    if(defined(&__GNUC__)) {
	eval 'sub __compiler_membar () {
	    eval q( &__asm  &__volatile(\\" \\" : : : \\"memory\\"));
	}' unless defined(&__compiler_membar);
	eval 'sub __CC_SUPPORTS___INLINE () {1;}' unless defined(&__CC_SUPPORTS___INLINE);
	eval 'sub __CC_SUPPORTS_SYMVER () {1;}' unless defined(&__CC_SUPPORTS_SYMVER);
    }
    if(defined(&__TINYC__)) {
	undef(&__CC_SUPPORTS_SYMVER) if defined(&__CC_SUPPORTS_SYMVER);
    }
    if(defined(&__STDC__) || defined(&__cplusplus)) {
	eval 'sub __P {
	    my($protos) = @_;
    	    eval q($protos);
	}' unless defined(&__P);
	eval 'sub __CONCAT1 {
	    my($x,$y) = @_;
    	    eval q($x  $y);
	}' unless defined(&__CONCAT1);
	eval 'sub __CONCAT {
	    my($x,$y) = @_;
    	    eval q( &__CONCAT1($x,$y));
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&__STRING);
	eval 'sub __XSTRING {
	    my($x) = @_;
    	    eval q( &__STRING($x));
	}' unless defined(&__XSTRING);
	eval 'sub __volatile () { &volatile;}' unless defined(&__volatile);
	if(defined(&__cplusplus)) {
	    eval 'sub __inline () { &inline;}' unless defined(&__inline);
	} else {
	    if(!(defined(&__CC_SUPPORTS___INLINE))) {
		eval 'sub __inline () {1;}' unless defined(&__inline);
	    }
	}
    } else {
	eval 'sub __P {
	    my($protos) = @_;
    	    eval q(());
	}' unless defined(&__P);
	eval 'sub __CONCAT {
	    my($x,$y) = @_;
    	    eval q($x $y);
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    my($x) = @_;
    	    eval q(\\"x\\");
	}' unless defined(&__STRING);
	if(!defined(&__CC_SUPPORTS___INLINE)) {
	    eval 'sub __inline () {1;}' unless defined(&__inline);
	    eval 'sub __volatile () {1;}' unless defined(&__volatile);
	}
    }
    eval 'sub __weak_symbol () { &__attribute__(( &__weak__));}' unless defined(&__weak_symbol);
    eval 'sub __dead2 () { &__attribute__(( &__noreturn__));}' unless defined(&__dead2);
    eval 'sub __pure2 () { &__attribute__(( &__const__));}' unless defined(&__pure2);
    eval 'sub __unused () { &__attribute__(( &__unused__));}' unless defined(&__unused);
    eval 'sub __used () { &__attribute__(( &__used__));}' unless defined(&__used);
    eval 'sub __deprecated () { &__attribute__(( &__deprecated__));}' unless defined(&__deprecated);
    eval 'sub __deprecated1 {
        my($msg) = @_;
	    eval q( &__attribute__(( &__deprecated__($msg))));
    }' unless defined(&__deprecated1);
    eval 'sub __packed () { &__attribute__(( &__packed__));}' unless defined(&__packed);
    eval 'sub __aligned {
        my($x) = @_;
	    eval q( &__attribute__(( &__aligned__($x))));
    }' unless defined(&__aligned);
    eval 'sub __section {
        my($x) = @_;
	    eval q( &__attribute__(( &__section__($x))));
    }' unless defined(&__section);
    eval 'sub __writeonly () { &__unused;}' unless defined(&__writeonly);
    eval 'sub __alloc_size {
        my($x) = @_;
	    eval q( &__attribute__(( &__alloc_size__($x))));
    }' unless defined(&__alloc_size);
    eval 'sub __alloc_size2 {
        my($n, $x) = @_;
	    eval q( &__attribute__(( &__alloc_size__($n, $x))));
    }' unless defined(&__alloc_size2);
    eval 'sub __alloc_align {
        my($x) = @_;
	    eval q( &__attribute__(( &__alloc_align__($x))));
    }' unless defined(&__alloc_align);
    if(!defined(&__STDC_VERSION__) || (defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) < 201112) {
	if(! &__has_extension((defined(&c_alignas) ? &c_alignas : undef))) {
	    if((defined(&__cplusplus)  && (defined(&__cplusplus) ? &__cplusplus : undef) >= 201103) ||  &__has_extension((defined(&cxx_alignas) ? &cxx_alignas : undef))) {
		eval 'sub _Alignas {
		    my($x) = @_;
    		    eval q( &alignas($x));
		}' unless defined(&_Alignas);
	    } else {
		eval 'sub _Alignas {
		    my($x) = @_;
    		    eval q( &__aligned($x));
		}' unless defined(&_Alignas);
	    }
	}
	if(defined(&__cplusplus)  && (defined(&__cplusplus) ? &__cplusplus : undef) >= 201103) {
	    eval 'sub _Alignof {
	        my($x) = @_;
    		eval q( &alignof($x));
	    }' unless defined(&_Alignof);
	} else {
	    eval 'sub _Alignof {
	        my($x) = @_;
    		eval q( &__alignof($x));
	    }' unless defined(&_Alignof);
	}
	if(defined(&__cplusplus)  && (defined(&__cplusplus) ? &__cplusplus : undef) >= 201103) {
	    eval 'sub _Noreturn () {[[ &noreturn]];}' unless defined(&_Noreturn);
	} else {
	    eval 'sub _Noreturn () { &__dead2;}' unless defined(&_Noreturn);
	}
	if(! &__has_extension((defined(&c_static_assert) ? &c_static_assert : undef))) {
	    if((defined(&__cplusplus)  && (defined(&__cplusplus) ? &__cplusplus : undef) >= 201103) ||  &__has_extension((defined(&cxx_static_assert) ? &cxx_static_assert : undef))) {
		eval 'sub _Static_assert {
		    my($x, $y) = @_;
    		    eval q( &static_assert($x, $y));
		}' unless defined(&_Static_assert);
	    }
	}
	if(! &__has_extension((defined(&c_thread_local) ? &c_thread_local : undef))) {
	    if((defined(&__cplusplus)  && (defined(&__cplusplus) ? &__cplusplus : undef) >= 201103) ||  &__has_extension((defined(&cxx_thread_local) ? &cxx_thread_local : undef))) {
		eval 'sub _Thread_local () { &thread_local;}' unless defined(&_Thread_local);
	    } else {
		eval 'sub _Thread_local () { &__thread;}' unless defined(&_Thread_local);
	    }
	}
    }
    if((defined(&__STDC_VERSION__)  && (defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) >= 201112) ||  &__has_extension((defined(&c_generic_selections) ? &c_generic_selections : undef))) {
	eval 'sub __generic {
	    my($expr, $t, $yes, $no) = @_;
    	    eval q( &_Generic($expr, $t: $yes,  &default: $no));
	}' unless defined(&__generic);
    }
 elsif(!defined(&__cplusplus)) {
	eval 'sub __generic {
	    my($expr, $t, $yes, $no) = @_;
    	    eval q( &__builtin_choose_expr( &__builtin_types_compatible_p(  &__typeof((( &void)0, ($expr))), $t), $yes, $no));
	}' unless defined(&__generic);
    }
    if(!defined(&__cplusplus)  && (!defined(&__STDC_VERSION__) || ((defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) >= 199901))) {
	eval 'sub __min_size {
	    my($x) = @_;
    	    eval q( &static ($x));
	}' unless defined(&__min_size);
    } else {
	eval 'sub __min_size {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&__min_size);
    }
    eval 'sub __malloc_like () { &__attribute__(( &__malloc__));}' unless defined(&__malloc_like);
    eval 'sub __pure () { &__attribute__(( &__pure__));}' unless defined(&__pure);
    eval 'sub __always_inline () { &__inline  &__attribute__(( &__always_inline__));}' unless defined(&__always_inline);
    eval 'sub __noinline () { &__attribute__ (( &__noinline__));}' unless defined(&__noinline);
    eval 'sub __fastcall () { &__attribute__(( &__fastcall__));}' unless defined(&__fastcall);
    eval 'sub __result_use_check () { &__attribute__(( &__warn_unused_result__));}' unless defined(&__result_use_check);
    eval 'sub __returns_twice () { &__attribute__(( &__returns_twice__));}' unless defined(&__returns_twice);
    eval 'sub __unreachable () {
        eval q( &__builtin_unreachable());
    }' unless defined(&__unreachable);
    if(!defined(&__STRICT_ANSI__) || (defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) >= 199901) {
	eval 'sub __LONG_LONG_SUPPORTED () {1;}' unless defined(&__LONG_LONG_SUPPORTED);
    }
    if(defined(&__cplusplus)  && (defined(&__cplusplus) ? &__cplusplus : undef) >= 201103) {
	eval 'sub __LONG_LONG_SUPPORTED () {1;}' unless defined(&__LONG_LONG_SUPPORTED);
	unless(defined(&__STDC_LIMIT_MACROS)) {
	    eval 'sub __STDC_LIMIT_MACROS () {1;}' unless defined(&__STDC_LIMIT_MACROS);
	}
	unless(defined(&__STDC_CONSTANT_MACROS)) {
	    eval 'sub __STDC_CONSTANT_MACROS () {1;}' unless defined(&__STDC_CONSTANT_MACROS);
	}
    }
    if(defined(&__cplusplus)  && (defined(&__cplusplus) ? &__cplusplus : undef) >= 201103) {
	eval 'sub __noexcept () { &noexcept;}' unless defined(&__noexcept);
	eval 'sub __noexcept_if {
	    my($__c) = @_;
    	    eval q( &noexcept($__c));
	}' unless defined(&__noexcept_if);
    } else {
	eval 'sub __noexcept () {1;}' unless defined(&__noexcept);
	eval 'sub __noexcept_if {
	    my($__c) = @_;
    	    eval q();
	}' unless defined(&__noexcept_if);
    }
    if(defined(&__cplusplus)  && defined(&__has_cpp_attribute)) {
	if( &__has_cpp_attribute((defined(&nodiscard) ? &nodiscard : undef))) {
	    eval 'sub __nodiscard () {[[ &nodiscard]];}' unless defined(&__nodiscard);
	}
    }
 elsif(defined(&__STDC_VERSION__)  && defined(&__has_c_attribute)) {
	if( &__has_c_attribute((defined(&__nodiscard__) ? &__nodiscard__ : undef))) {
	    eval 'sub __nodiscard () {[[ &__nodiscard__]];}' unless defined(&__nodiscard);
	}
    }
    unless(defined(&__nodiscard)) {
	if(defined(&__clang__)) {
	    eval 'sub __nodiscard () { &__attribute__(( &__warn_unused_result__));}' unless defined(&__nodiscard);
	} else {
	    eval 'sub __nodiscard () {1;}' unless defined(&__nodiscard);
	}
    }
    if(defined(&__STDC_VERSION__)  && (defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) >= 199901) {
	eval 'sub __restrict () { &restrict;}' unless defined(&__restrict);
    }
    eval 'sub __predict_true {
        my($exp) = @_;
	    eval q( &__builtin_expect(($exp), 1));
    }' unless defined(&__predict_true);
    eval 'sub __predict_false {
        my($exp) = @_;
	    eval q( &__builtin_expect(($exp), 0));
    }' unless defined(&__predict_false);
    eval 'sub __null_sentinel () { &__attribute__(( &__sentinel__));}' unless defined(&__null_sentinel);
    eval 'sub __exported () { &__attribute__(( &__visibility__("default")));}' unless defined(&__exported);
    eval 'sub __hidden () { &__attribute__(( &__visibility__("hidden")));}' unless defined(&__hidden);
    eval 'sub __offsetof {
        my($type, $field) = @_;
	    eval q( &__builtin_offsetof($type, $field));
    }' unless defined(&__offsetof);
    eval 'sub __rangeof {
        my($type, $start, $end) = @_;
	    eval q(( &__offsetof($type, $end) -  &__offsetof($type, $start)));
    }' unless defined(&__rangeof);
    eval 'sub __containerof {
        my($x, $s, $m) = @_;
	    eval q(({  &const  &volatile  &__typeof((($s *)0)->$m) * &__x = ($x);  &__DEQUALIFY($s *, ( &const  &volatile \'char\' *) &__x -  &__offsetof($s, $m));}));
    }' unless defined(&__containerof);
    eval 'sub __printflike {
        my($fmtarg, $firstvararg) = @_;
	    eval q( &__attribute__(( &__format__ ( &__printf__, $fmtarg, $firstvararg))));
    }' unless defined(&__printflike);
    eval 'sub __scanflike {
        my($fmtarg, $firstvararg) = @_;
	    eval q( &__attribute__(( &__format__ ( &__scanf__, $fmtarg, $firstvararg))));
    }' unless defined(&__scanflike);
    eval 'sub __format_arg {
        my($fmtarg) = @_;
	    eval q( &__attribute__(( &__format_arg__ ($fmtarg))));
    }' unless defined(&__format_arg);
    eval 'sub __strfmonlike {
        my($fmtarg, $firstvararg) = @_;
	    eval q( &__attribute__(( &__format__ ( &__strfmon__, $fmtarg, $firstvararg))));
    }' unless defined(&__strfmonlike);
    eval 'sub __strftimelike {
        my($fmtarg, $firstvararg) = @_;
	    eval q( &__attribute__(( &__format__ ( &__strftime__, $fmtarg, $firstvararg))));
    }' unless defined(&__strftimelike);
    if(defined(&__clang__) || (defined(&__GNUC__)  && defined (&__FreeBSD_cc_version))) {
	eval 'sub __printf0like {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__printf0__, $fmtarg, $firstvararg))));
	}' unless defined(&__printf0like);
    } else {
	eval 'sub __printf0like {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q();
	}' unless defined(&__printf0like);
    }
    eval 'sub __strong_reference {
        my($sym,$aliassym) = @_;
	    eval q( &extern  &__typeof ($sym) $aliassym  &__attribute__ (( &__alias__ ($sym))));
    }' unless defined(&__strong_reference);
    if(defined(&__STDC__)) {
	eval 'sub __weak_reference {
	    my($sym,$alias) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__weak_reference);
	eval 'sub __warn_references {
	    my($sym,$msg) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__warn_references);
	if(defined(&__CC_SUPPORTS_SYMVER)) {
	    eval 'sub __sym_compat {
	        my($sym,$impl,$verid) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__sym_compat);
	    eval 'sub __sym_default {
	        my($sym,$impl,$verid) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__sym_default);
	}
    } else {
	eval 'sub __weak_reference {
	    my($sym,$alias) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__weak_reference);
	eval 'sub __warn_references {
	    my($sym,$msg) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__warn_references);
	if(defined(&__CC_SUPPORTS_SYMVER)) {
	    eval 'sub __sym_compat {
	        my($sym,$impl,$verid) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__sym_compat);
	    eval 'sub __sym_default {
	        my($impl,$sym,$verid) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__sym_default);
	}
    }
    eval 'sub __GLOBL {
        my($sym) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__GLOBL);
    eval 'sub __WEAK {
        my($sym) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__WEAK);
    eval 'sub __IDSTRING {
        my($name,$string) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__IDSTRING);
    unless(defined(&__FBSDID)) {
	if(!defined(&STRIP_FBSDID)) {
	    eval 'sub __FBSDID {
	        my($s) = @_;
    		eval q( &__IDSTRING( &__CONCAT( &__rcsid_, &__LINE__),$s));
	    }' unless defined(&__FBSDID);
	} else {
	    eval 'sub __FBSDID {
	        my($s) = @_;
    		eval q(\'struct __hack\');
	    }' unless defined(&__FBSDID);
	}
    }
    unless(defined(&__RCSID)) {
	unless(defined(&NO__RCSID)) {
	    eval 'sub __RCSID {
	        my($s) = @_;
    		eval q( &__IDSTRING( &__CONCAT( &__rcsid_, &__LINE__),$s));
	    }' unless defined(&__RCSID);
	} else {
	    eval 'sub __RCSID {
	        my($s) = @_;
    		eval q(\'struct __hack\');
	    }' unless defined(&__RCSID);
	}
    }
    unless(defined(&__RCSID_SOURCE)) {
	unless(defined(&NO__RCSID_SOURCE)) {
	    eval 'sub __RCSID_SOURCE {
	        my($s) = @_;
    		eval q( &__IDSTRING( &__CONCAT( &__rcsid_source_, &__LINE__),$s));
	    }' unless defined(&__RCSID_SOURCE);
	} else {
	    eval 'sub __RCSID_SOURCE {
	        my($s) = @_;
    		eval q(\'struct __hack\');
	    }' unless defined(&__RCSID_SOURCE);
	}
    }
    unless(defined(&__SCCSID)) {
	unless(defined(&NO__SCCSID)) {
	    eval 'sub __SCCSID {
	        my($s) = @_;
    		eval q( &__IDSTRING( &__CONCAT( &__sccsid_, &__LINE__),$s));
	    }' unless defined(&__SCCSID);
	} else {
	    eval 'sub __SCCSID {
	        my($s) = @_;
    		eval q(\'struct __hack\');
	    }' unless defined(&__SCCSID);
	}
    }
    unless(defined(&__COPYRIGHT)) {
	unless(defined(&NO__COPYRIGHT)) {
	    eval 'sub __COPYRIGHT {
	        my($s) = @_;
    		eval q( &__IDSTRING( &__CONCAT( &__copyright_, &__LINE__),$s));
	    }' unless defined(&__COPYRIGHT);
	} else {
	    eval 'sub __COPYRIGHT {
	        my($s) = @_;
    		eval q(\'struct __hack\');
	    }' unless defined(&__COPYRIGHT);
	}
    }
    unless(defined(&__DECONST)) {
	eval 'sub __DECONST {
	    my($type, $var) = @_;
    	    eval q((($type)( &__uintptr_t)( &const  &void *)($var)));
	}' unless defined(&__DECONST);
    }
    unless(defined(&__DEVOLATILE)) {
	eval 'sub __DEVOLATILE {
	    my($type, $var) = @_;
    	    eval q((($type)( &__uintptr_t)( &volatile  &void *)($var)));
	}' unless defined(&__DEVOLATILE);
    }
    unless(defined(&__DEQUALIFY)) {
	eval 'sub __DEQUALIFY {
	    my($type, $var) = @_;
    	    eval q((($type)( &__uintptr_t)( &const  &volatile  &void *)($var)));
	}' unless defined(&__DEQUALIFY);
    }
    if(!defined(&_STANDALONE)  && !defined(&_KERNEL)) {
	eval 'sub __RENAME {
	    my($x) = @_;
    	    eval q( &__asm( &__STRING($x)));
	}' unless defined(&__RENAME);
    } else {
	eval 'sub __RENAME {
	    my($x) = @_;
    	    eval q( &no  &renaming  &in  &kernel/ &standalone  &environment);
	}' unless defined(&__RENAME);
    }
    require 'sys/_visible.ph';
    if(!(defined(&__clang__)  &&  &__has_feature((defined(&nullability) ? &nullability : undef)))) {
	eval 'sub _Nonnull () {1;}' unless defined(&_Nonnull);
	eval 'sub _Nullable () {1;}' unless defined(&_Nullable);
	eval 'sub _Null_unspecified () {1;}' unless defined(&_Null_unspecified);
	eval 'sub __NULLABILITY_PRAGMA_PUSH () {1;}' unless defined(&__NULLABILITY_PRAGMA_PUSH);
	eval 'sub __NULLABILITY_PRAGMA_POP () {1;}' unless defined(&__NULLABILITY_PRAGMA_POP);
    } else {
	eval 'sub __NULLABILITY_PRAGMA_PUSH () { &_Pragma("clang diagnostic push")  &_Pragma("clang diagnostic ignored \\"-Wnullability-completeness\\"");}' unless defined(&__NULLABILITY_PRAGMA_PUSH);
	eval 'sub __NULLABILITY_PRAGMA_POP () { &_Pragma("clang diagnostic pop");}' unless defined(&__NULLABILITY_PRAGMA_POP);
    }
    if( &__has_attribute((defined(&__argument_with_type_tag__) ? &__argument_with_type_tag__ : undef))  &&  &__has_attribute((defined(&__type_tag_for_datatype__) ? &__type_tag_for_datatype__ : undef))) {
	eval 'sub __arg_type_tag {
	    my($arg_kind, $arg_idx, $type_tag_idx) = @_;
    	    eval q( &__attribute__(( &__argument_with_type_tag__($arg_kind, $arg_idx, $type_tag_idx))));
	}' unless defined(&__arg_type_tag);
	eval 'sub __datatype_type_tag {
	    my($kind, $type) = @_;
    	    eval q( &__attribute__(( &__type_tag_for_datatype__($kind, $type))));
	}' unless defined(&__datatype_type_tag);
    } else {
	eval 'sub __arg_type_tag {
	    my($arg_kind, $arg_idx, $type_tag_idx) = @_;
    	    eval q();
	}' unless defined(&__arg_type_tag);
	eval 'sub __datatype_type_tag {
	    my($kind, $type) = @_;
    	    eval q();
	}' unless defined(&__datatype_type_tag);
    }
    if( &__has_extension((defined(&c_thread_safety_attributes) ? &c_thread_safety_attributes : undef))) {
	eval 'sub __lock_annotate {
	    my($x) = @_;
    	    eval q( &__attribute__(($x)));
	}' unless defined(&__lock_annotate);
    } else {
	eval 'sub __lock_annotate {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&__lock_annotate);
    }
    eval 'sub __lockable () { &__lock_annotate( &lockable);}' unless defined(&__lockable);
    eval 'sub __locks_exclusive () {(...)  &__lock_annotate( &exclusive_lock_function( &__VA_ARGS__));}' unless defined(&__locks_exclusive);
    eval 'sub __locks_shared () {(...)  &__lock_annotate( &shared_lock_function( &__VA_ARGS__));}' unless defined(&__locks_shared);
    eval 'sub __trylocks_exclusive () {(...)  &__lock_annotate( &exclusive_trylock_function( &__VA_ARGS__));}' unless defined(&__trylocks_exclusive);
    eval 'sub __trylocks_shared () {(...)  &__lock_annotate( &shared_trylock_function( &__VA_ARGS__));}' unless defined(&__trylocks_shared);
    eval 'sub __unlocks () {(...)  &__lock_annotate( &unlock_function( &__VA_ARGS__));}' unless defined(&__unlocks);
    eval 'sub __asserts_exclusive () {(...)  &__lock_annotate( &assert_exclusive_lock( &__VA_ARGS__));}' unless defined(&__asserts_exclusive);
    eval 'sub __asserts_shared () {(...)  &__lock_annotate( &assert_shared_lock( &__VA_ARGS__));}' unless defined(&__asserts_shared);
    eval 'sub __requires_exclusive () {(...)  &__lock_annotate( &exclusive_locks_required( &__VA_ARGS__));}' unless defined(&__requires_exclusive);
    eval 'sub __requires_shared () {(...)  &__lock_annotate( &shared_locks_required( &__VA_ARGS__));}' unless defined(&__requires_shared);
    eval 'sub __requires_unlocked () {(...)  &__lock_annotate( &locks_excluded( &__VA_ARGS__));}' unless defined(&__requires_unlocked);
    eval 'sub __no_lock_analysis () { &__lock_annotate( &no_thread_safety_analysis);}' unless defined(&__no_lock_analysis);
    if( &__has_feature((defined(&address_sanitizer) ? &address_sanitizer : undef))  && defined(&__clang__)) {
	if(defined(&_KERNEL)) {
	    eval 'sub __nosanitizeaddress () { &__attribute__(( &no_sanitize("kernel-address")));}' unless defined(&__nosanitizeaddress);
	} else {
	    eval 'sub __nosanitizeaddress () { &__attribute__(( &no_sanitize("address")));}' unless defined(&__nosanitizeaddress);
	}
    } else {
	eval 'sub __nosanitizeaddress () {1;}' unless defined(&__nosanitizeaddress);
    }
    if( &__has_feature((defined(&coverage_sanitizer) ? &coverage_sanitizer : undef))  && defined(&__clang__)) {
	eval 'sub __nosanitizecoverage () { &__attribute__(( &no_sanitize("coverage")));}' unless defined(&__nosanitizecoverage);
    } else {
	eval 'sub __nosanitizecoverage () {1;}' unless defined(&__nosanitizecoverage);
    }
    if( &__has_feature((defined(&memory_sanitizer) ? &memory_sanitizer : undef))  && defined(&__clang__)) {
	if(defined(&_KERNEL)) {
	    eval 'sub __nosanitizememory () { &__attribute__(( &no_sanitize("kernel-memory")));}' unless defined(&__nosanitizememory);
	} else {
	    eval 'sub __nosanitizememory () { &__attribute__(( &no_sanitize("memory")));}' unless defined(&__nosanitizememory);
	}
    } else {
	eval 'sub __nosanitizememory () {1;}' unless defined(&__nosanitizememory);
    }
    if( &__has_feature((defined(&thread_sanitizer) ? &thread_sanitizer : undef))  && defined(&__clang__)) {
	eval 'sub __nosanitizethread () { &__attribute__(( &no_sanitize("thread")));}' unless defined(&__nosanitizethread);
    } else {
	eval 'sub __nosanitizethread () {1;}' unless defined(&__nosanitizethread);
    }
    if( &__has_attribute((defined(&no_stack_protector) ? &no_stack_protector : undef))) {
	eval 'sub __nostackprotector () { &__attribute__(( &no_stack_protector));}' unless defined(&__nostackprotector);
    } else {
	eval 'sub __nostackprotector () { &__attribute__(( &__optimize__("-fno-stack-protector")));}' unless defined(&__nostackprotector);
    }
    eval 'sub __guarded_by {
        my($x) = @_;
	    eval q( &__lock_annotate( &guarded_by($x)));
    }' unless defined(&__guarded_by);
    eval 'sub __pt_guarded_by {
        my($x) = @_;
	    eval q( &__lock_annotate( &pt_guarded_by($x)));
    }' unless defined(&__pt_guarded_by);
    if(! &__has_builtin((defined(&__builtin_is_aligned) ? &__builtin_is_aligned : undef))) {
	eval 'sub __builtin_is_aligned {
	    my($x, $align) = @_;
    	    eval q(((( &__uintptr_t)($x) & (($align) - 1)) == 0));
	}' unless defined(&__builtin_is_aligned);
    }
    if(! &__has_builtin((defined(&__builtin_align_up) ? &__builtin_align_up : undef))) {
	eval 'sub __builtin_align_up {
	    my($x, $align) = @_;
    	    eval q((( &__typeof__($x))((( &__uintptr_t)($x)+(($align)-1))(~(($align)-1)))));
	}' unless defined(&__builtin_align_up);
    }
    if(! &__has_builtin((defined(&__builtin_align_down) ? &__builtin_align_down : undef))) {
	eval 'sub __builtin_align_down {
	    my($x, $align) = @_;
    	    eval q((( &__typeof__($x))(($x)(~(($align)-1)))));
	}' unless defined(&__builtin_align_down);
    }
    eval 'sub __align_up {
        my($x, $y) = @_;
	    eval q( &__builtin_align_up($x, $y));
    }' unless defined(&__align_up);
    eval 'sub __align_down {
        my($x, $y) = @_;
	    eval q( &__builtin_align_down($x, $y));
    }' unless defined(&__align_down);
    eval 'sub __is_aligned {
        my($x, $y) = @_;
	    eval q( &__builtin_is_aligned($x, $y));
    }' unless defined(&__is_aligned);
}
1;
